package alena.checkers;

import org.eclipse.cdt.codan.core.cxx.model.AbstractAstFunctionChecker;
import org.eclipse.cdt.codan.core.model.IChecker;
import org.eclipse.cdt.codan.core.model.IProblemWorkingCopy;
import org.eclipse.cdt.core.dom.ast.ASTVisitor;
import org.eclipse.cdt.core.dom.ast.IASTExpression;
import org.eclipse.cdt.core.dom.ast.IASTFunctionCallExpression;
import org.eclipse.cdt.core.dom.ast.IASTFunctionDefinition;

public class GetsChecker extends AbstractAstFunctionChecker implements IChecker {
	public static String ID = "alena.checkers.gets";
	public static String PARAM_FUNC = "fname";
	private String aname;

	public GetsChecker() {

	}

	class FunctionCallVisitor extends ASTVisitor {

		FunctionCallVisitor(IASTFunctionDefinition func) {
			shouldVisitExpressions = true;
		}

		public int visit(IASTExpression expr) {
			if (expr instanceof IASTFunctionCallExpression) {
				IASTExpression fname = ((IASTFunctionCallExpression) expr)
						.getFunctionNameExpression();
				String name = fname.getRawSignature();
		
				if (name.equals(aname)) {
					reportProblem(ID, fname, name,"242");
					return PROCESS_SKIP;
				}
			}
			return PROCESS_CONTINUE;
		}

	}

	@Override
	protected void processFunction(IASTFunctionDefinition func) {
		aname = (String) getPreference(getProblemById(ID, getFile()), PARAM_FUNC);
		FunctionCallVisitor visitor = new FunctionCallVisitor(func);
		func.accept(visitor);

	}

	@Override
	public void initPreferences(IProblemWorkingCopy problem) {
		super.initPreferences(problem);
		addPreference(problem, PARAM_FUNC, "Function Name", "gets");
	}

}
