
package alena.checkers;

import org.eclipse.cdt.codan.ui.AbstractCodanCMarkerResolution;
import org.eclipse.core.resources.IMarker;
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.FindReplaceDocumentAdapter;
import org.eclipse.jface.text.IDocument;

/**
 * quick fix for assignment in condition
 */
public class QuickFixGets extends AbstractCodanCMarkerResolution {
	public String getLabel() {
		return "Replaces with fgets";
	}

	
	@Override
	public boolean isApplicable(IMarker marker) {
		String arg = getProblemArgument(marker, 0);
		if ("gets".equals(arg))
			return true;
		else return false;
	}
	@Override
	public void apply(IMarker marker, IDocument document) {
		int pos = getOffset(marker, document);
		try {
			FindReplaceDocumentAdapter dad = new FindReplaceDocumentAdapter(document);
			dad.find(pos, "gets\\s*\\((.*)\\)", /* forwardSearch *///$NON-NLS-1$
					true, /* caseSensitive */false,
					/* wholeWord */false, /* regExSearch */true);
			dad.replace("fgets(\\1,sizeof(\\1),stdin)", /* regExReplace */true); //$NON-NLS-1$

		} catch (BadLocationException e) {
			Activator.log(e);
		}
	}
}
